#ifndef __convert1_hh__
#define __convert1_hh__

using namespace std ;
#include "defs.h"
#include <stdlib.h>

#pragma warning(disable: 4244)
#pragma warning(disable: 4800)

template <class Type> class mysql_convert;

#define mysql__convert(TYPE, FUNC) \
  template <> \
  class mysql_convert<TYPE> {\
  private:\
    TYPE num;\
  public:\
    mysql_convert(const char* str, const char *& end) { \
      num = FUNC(str, const_cast<char **>(&end));}\
    operator TYPE () {return num;}\
  };\

//extern double strtod (const char *, char **);	????

mysql__convert(float, std::strtod)
mysql__convert(double, std::strtod)

#undef mysql__convert
#define mysql__convert(TYPE, FUNC) \
  template <> \
  class mysql_convert<TYPE> {\
  private:\
    TYPE num;\
  public:\
    mysql_convert(const char* str, const char *& end) { \
      num = FUNC(str, const_cast<char **>(&end),10);}\
    operator TYPE () {return num;}\
  };\

//extern long strtol(const char *str, char **ptr, int base);			????
//extern unsigned long strtoul(const char *str, char **ptr, int base);	????

mysql__convert(char, std::strtol)
mysql__convert(signed char, std::strtol)
mysql__convert(int, std::strtol)
mysql__convert(short int, std::strtol)
mysql__convert(long int, std::strtol)

mysql__convert(unsigned char, std::strtoul)
mysql__convert(unsigned int, std::strtoul)
mysql__convert(unsigned short int, std::strtoul)
mysql__convert(unsigned long int, std::strtoul)

#endif



